typedef struct
{
	POV:4;
	B4:1;
	B5:1;
	B6:1;
	B7:1;
}byte_bits;

typedef union
{
	unsigned char byte;
	byte_bits bit;
}byte;

char read[64],write[64];
unsigned char temp,pov;
char x_axis,y_axis,throttle=0;

void interrupt(void)
{
	HID_InterruptProc();
}

void main(void)
{
	byte buttons;
	
	buttons.byte=0;
	
	//Initialize ports
	TRISB=255;  //Set port b to inputs - Port b samples all the digital switches

	HID_Enable(read,write);
 
	while(1)
	{
	    /////////////////////////////////
	    //Joystick buttons
		/////////////////////////////////
		//Button 1
     	if (PORTB.RB0)
	        buttons.bit.B4=1;
		else
		    buttons.bit.B4=0;
		//Button 2
	    if (PORTB.RB1)
	        buttons.bit.B5=1;
		else
		    buttons.bit.B5=0;
		//Button 3
   	    if (PORTB.RB2)
	        buttons.bit.B6=1;
		else
		    buttons.bit.B6=0;
		//Button 4
   	    if (PORTB.RB3)
	        buttons.bit.B7=1;
		else
		    buttons.bit.B7=0;

		///////////////////////////////////
		//POV Hat
		///////////////////////////////////
		pov=Adc_Read(0)>>2;
		
		buttons.bit.POV=4;  //idle
		if (pov<=193 && pov>=176)   //Left
		    buttons.bit.POV=3;
		if (pov<=175 && pov>=143)   //Down
		    buttons.bit.POV=2;
		if (pov<=142 && pov>=61)    //Right
		    buttons.bit.POV=1;
		if (pov<=60 && pov>=0)      //Up
		    buttons.bit.POV=0;

		///////////////////////////////
		//Joystick Axes
		x_axis=(Adc_Read(1)>>2)-128;      //Read only the top 8-bits of the ADC
		y_axis=(Adc_Read(2)>>2)-128;
		throttle=(Adc_Read(3)>>2)-128;
		//////////////////////////////
		//USB
		write[0]=throttle;
		write[1]=x_axis;
		write[2]=y_axis;
		write[3]=buttons.byte;
		
		while(!HID_Write(write,4));

	}
}